(****************************************************************************)
(*                                                    *)
(*                                                                 *)
(*                                                           *)
(*                                                                 *)
(*                                                          *)
(*                                                                          *)
(*                         (First major rewrite!)                           *)
(*                                                                          *)
(*            CopyRight 1992-1993 ----POWER SYSTEMS---- Inc.                *)
(*            Original Code by MERCURY (Bryan Murphy).                      *)
(*                                                                          *)
(*    Thanks goes to many people for their ideas, ontributions, and help!   *)
(****************************************************************************

                              OTERA BBS PROGRAM
                     Copyright 1992-1993 by Bryan Murphy

 Distribution of the source codes to OTERA in any form wether it be modified
 or unmodified is strictly prohibited without prior written consent of the
 author.  Any possesion of the source codes at all is considered as holding
 stolen material.  Distribution of compiled copies of OTERA is strictly lim-
 ited to the author.  With proper written consent, the authorship may be
 transfered to a new person, LEAVING the original owner with a LEGAL copy of
 the source code.

*****************************************************************************)
{$I-,F-,O-,E+,D-,L-,A-,G+,R-,S-,X+}
{$M 64536,157200,157200} {307200} {207200}
PROGRAM OTERA;

USES
  CallOvr , Dos     , Crt     , Mercury , Fossil  , GenTypes, Modem   ,
  Misc    , Common  , Ems     ,  Swap   , FidoNet , Files   , Logon   ,
  Config  , Online  , Messages, Editors , Menu1   , PckdTime, Menu2   ,
  Xfer    , Files2;

{$O Common   }  { Functions for Local SysOp Menu }
{$O Mercury  }  { Various General Functions }
{$O FidoNet  }  { FidoNet Functions and Procedures }
{$O Files    }  { General Functions for Overlay }
{$O Config   }  { System Configuration }
{$O Messages }  { Message Routines }
{$O Menu1    }  { Menu Editor }
{$O Menu2    }  { General Menu Routines for Overlay }
{$O Users    }  { User Routines }
{$O Xfer     }  { Files Section Routines }
{$O Files2   }  { More General Functions for Overlay }

CONST Local:Boolean=False;
VAR OldExit:Pointer;
    OldDiv:Pointer;

{$F+}
PROCEDURE OteraExit;
{$F-}
Begin
  Cursor(True);
  Savestatus;
  SetIntVec($00,OldDiv);
  ExitProc:=OldExit;
End;

PROCEDURE Divide; Interrupt;
Begin
  Write(^G);
  Exit;
End;

PROCEDURE GetParams;
VAR I:Integer;
Begin
  For I:=1 to ParamCount do
    Begin
      If Upper(ParamStr(I))='-B' then
        Begin
          Inc(I);
          If ParamStr(I)='38400' then Rate:=38400 else Rate:=Intt(ParamStr(I));
          Connect:=True;
        End else
      If Upper(ParamStr(I))='-C' then
        Begin
          Inc(I);
          ComPort:=Intt(ParamStr(I));
        End else
      If Upper(ParamStr(I))='-N' then
        Begin
          Inc(I);
          Node:=Intt(ParamStr(I));
        End else
      If Upper(ParamStr(I))='-L' then
        Begin
          Connect:=True;
          Local:=True;
        End else
        Writeln('Unrecognized Commandline Paramater: ',ParamStr(I));
    End;
End;

VAR DSZ,DszLog:Boolean; I:Byte;

PROCEDURE Quit(B:Byte);
Begin
  Writeln('Halting Execution...');
  Halt(B);
End;

Begin
  Cursor(False);
  OldExit:=ExitProc;
  ExitProc:=@OteraExit;
  GetIntVec($00,OldDiv);
  SetIntVec($00,@Divide);
  Tc(7); Tb(0);
  ClrScr;
  MenuPtr:=@MenuEditor;
  Flags[1]:=False;
  Node:=1;
  Rate:=0;
  QuickLogoff:=False;
  Base.Description:='';
  DirectVideo:=Not Sys.Bios;
  Center('Initializing System'); Cr;
  ComPort:=Sys.ComPort;
  Rate:=Sys.BaudRate;
  If ParamCount>0 then GetParams;
  Center('XYZ.PAS!'); Writeln;
  If Not InitializeModem(Rate) then
    Begin
      Cr;
      Writeln(' [] Fossil driver not found! []');
      Halt(3);
    End;
  If Upper(GetEnv('DSZLOG'))<>Upper(Sys.MainDir)+'\DSZ.'+Strr(Node) then
    Begin
      DszLog:=False;
      Writeln('Put SET DSZLOG='+Sys.MainDir+'\DSZ.'+Strr(Node)+' in your Environment!');
    End else DszLog:=True;
  If (Not Exist('DSZ.COM')) and (Not Exist('GSZ.EXE')) then
    Begin
      Dsz:=False;
      Writeln('DSZ.COM or GSZ.EXE not found in main directory!');
    End else Dsz:=True;
  If Not Exist('PKUNZIP.EXE') then
    Begin
      Writeln('PKUNZIP.EXE not found in main directory!');
      Quit(10);
    End;
  If Not DSZ then Quit(9);
  If Not DSZlog then Quit(8);
  ReadDataFiles;
  Swap_FileName:='OTERA$$.'+Strr(Node);
  {**}
  If Connect then
    Begin
      Flags[2]:=True;
      Emulation:=Ansi;
      User.HotKeys:=False;
      QuickLogoff:=False;
      If Local then Flags[1]:=True;
      If (Carrier) or (Local) then Logon_to_BBS;
    End else
 Begin
  SysOpScreen;
  SendInitString;
  GetFirstEvent;
  Repeat
    If (Carrier) or (OnLocal) or (DoLogon) then Logon_to_BBS else
    If (CharsWaiting) and (Not Carrier) then GetModemInput else
    GetNextEvent;
  Until (EndBBS);
 End;
  {**}
  DeinstallModem;
  SaveStatus;
  DisplayFont(0);
  Tc(14); Tb(0);
  ClrScr;
  Writeln('            OTERA EXITED WITH ERROR LEVEL 0 AT '+TIME(TRUE)+' ON '+TODAY+'.');
End.
